DMainMenu = {}

function DMainMenu:New()
	local obj = {}

	local width, height = love.graphics.getWidth(), love.graphics.getHeight()
	
	obj.w = 116
	obj.h = 114
	obj.x = width/2 - obj.w/2
	obj.y = height/2 - obj.h/2
	
	obj.header = "[ Main Menu ]"
	obj.text = "  A: Save\n  B: Save As\n  X: Load\n  Y: New\nSEL: Quit\n ST: Back"
	
	obj.colors = {
		bg = { 156, 23, 24 },
		text = { 255, 255, 255 },
		border = { 0, 0, 0 }
	}
	
	statusBar.message = "(Key Corresponds to Action.)"
	
	loadfilename = TextBox:New("", obj.x + 2, obj.y + 40, obj.w - 4, 20)
	
	function obj:draw()
		love.graphics.setFont(fonts.dialog)
		love.graphics.setColor( self.colors.bg )
		love.graphics.rectangle("fill", self.x, self.y, self.w, self.h )
		love.graphics.setColor( 255, 255, 255, 100 )
		love.graphics.rectangle("line", self.x, self.y, self.w, self.h )
		love.graphics.setColor( self.colors.text )
		love.graphics.printf( self.header, self.x, self.y, self.w, "center" )
		love.graphics.setFont(fonts.editor)
		love.graphics.printf( self.text, self.x+6, self.y+24, self.w, "left" )
	end
	
	function obj:keypressed(key, unicode)
		if key == Controls.Start then
			CloseDialog()
		elseif key == Controls.Select then
			love.event.push("q")
		elseif key == Controls.X then
			ChangeDialog( DLoadFile:New() )
		elseif key == Controls.B then
			ChangeDialog( DSaveFile:New() )
		elseif key == Controls.A then
			CloseDialog()
			SaveFile()
		end
	end
	return obj
end