local function getDirection()
	local up = love.keyboard.isDown( Controls.Up )
	local down = love.keyboard.isDown( Controls.Down )
	local left = love.keyboard.isDown( Controls.Left )
	local right = love.keyboard.isDown( Controls.Right )

	if (up and down) or (left and right) then return "c" end
	
	if left and down then return "ld"
	elseif left and up then return "lu"
	elseif right and down then return "rd"
	elseif right and up then return "ru"
	elseif up then return "u"
	elseif down then return "d"
	elseif left then return "l"
	elseif right then return "r" end
	return "c"
end

local function getChosen()
	local bottom, left, right, top = false, false, false, false

	bottom = love.keyboard.isDown( Controls.B )
	left = love.keyboard.isDown( Controls.Y )
	right = love.keyboard.isDown( Controls.A )
	top = love.keyboard.isDown( Controls.X )
	
	if left and bottom then chosen = 1
	elseif left and top then chosen = 3
	elseif right and bottom then chosen = 7
	elseif right and top then chosen = 9
	elseif bottom then chosen = 4
	elseif left then chosen = 2
	elseif top then chosen = 6
	elseif right then chosen = 8
	elseif not left and not right and not top and not bottom then chosen = 5 end
	
	return chosen
end

local function getCase()
	if love.keyboard.isDown( Controls.L ) then return "upper" end
	return "lower"
end

local function typeChar(case, dir, chosen)
	return charTable[getCase()][getDirection()][getChosen()]
end

function helpDisplay()
	return charTable[getCase()]["d"][getChosen()]
		.. charTable[getCase()]["l"][getChosen()]
		.. charTable[getCase()]["u"][getChosen()]
		.. charTable[getCase()]["r"][getChosen()]
end

function textInput(str, cpos)
	local newstr = str
	local newcpos = cpos
	if love.keyboard.isDown("c") then
		newcpos = (cpos>1) and cpos-1 or cpos
	end
	if love.keyboard.isDown("v") then
		newcpos = (cpos<#str+1) and cpos+1 or cpos
	end
	if love.keyboard.isDown(Controls.R) and not love.keyboard.isDown(Controls.L) then
		if cpos > 1 then
			newstr = string.sub(str, 1, cpos-2) .. string.sub(str, cpos)
			newcpos = cpos - 1
		end
	end
	--[[
		if cpos == #str then
			newstr = string.sub(str, 1, cpos-1) .. string.sub(str, cpos)
			cpos = cpos - 1
		else
			newstr = string.sub(str, 1, cpos-2)
			cpos = cpos - 1
			--newstr = string.sub(str, 1, #str-1)
		end
	end
	]]
	local dir = getDirection()
	if dir ~= "c" and (dir == "u" or dir =="d" or dir =="l" or dir == "r") then
		if love.keyboard.isDown(Controls.L) and love.keyboard.isDown(Controls.R) then
			if dir == "l" then newcpos = (cpos>1) and cpos-1 or cpos end
			if dir == "r" then newcpos = (cpos<#str+1) and cpos+1 or cpos end
		else
			newstr = string.sub(str, 1, cpos-1) .. typeChar() .. string.sub(str, cpos)
			newcpos = cpos + 1
		end
	end
	--[[
		if cpos then
			cpos = cpos + 1
			newstr = string.sub(str, 1, cpos) .. typeChar() .. string.sub(str, cpos)
		else
			newstr = str..typeChar()
		end
	end
	]]
	return newstr, newcpos
end



charTable = {
	lower = {
		d = { "a", "b", "c", "d", "e", "f", "g", "h", "i" },
		l = { "j", "k", "l", "m", "n", "o", "p", "q", "r" },
		u = { "s", "t", "u", "v", "w", "x", "y", "z", "\n" },
		r = { "/", ".", "!", "<", " ", "-", "|", ">", "?" }
	},
	upper = {
		d = { "A", "B", "C", "D", "E", "F", "G", "H", "I" },
		l = { "J", "K", "L", "M", "N", "O", "P", "Q", "R" },
		u = { "S", "T", "U", "V", "W", "X", "Y", "Z", "0" },
		r = { "1", "2", "3", "4", "5", "6", "7", "8", "9" }
	}
}