--[[
On the Dingoo A320 OpenDingux,
the controls are like this:
(copied from the wiki)

__DINGOO__      __KEYBOARD__    __LOVE2d__
D-pad up	KEY_UP		"up"
D-pad down	KEY_DOWN 	"down"
D-pad left	KEY_LEFT	"left"
D-pad right	KEY_RIGHT	"right"
A button	KEY_LEFTCTRL	"lctrl"
B button	KEY_LEFTALT	"lalt"
X button	KEY_SPACE	" "
Y button	KEY_LEFTSHIFT	"lshift"
Left shoulder	KEY_TAB		"tab"
Right shoulder	KEY_BACKSPACE	"backspace"
START button	KEY_ENTER	"return"
SELECT button	KEY_ESC		"escape"
Power slider	KEY_POWER	"power"
Power hold	KEY_PAUSE	"pause"
--]]

-- What Platform? 
-- Possible Choices:  "PC" "Dingoo"

platform = "Dingoo"

if platform == "Dingoo" then
	-- DINGOO SCHEME --
	Controls = {
		A = "lctrl",
		B = "lalt",
		X = " ",
		Y = "lshift",
		L = "tab",
		R = "backspace",
		Start = "return",
		Select = "escape",
		Up = "up",
		Down = "down",
		Left = "left",
		Right = "right",
		Power = "power",
		Hold = "pause"
	}
elseif platform == "PC" then
	-- PC SCHEME --
	Controls = {
		A = "l",
		B = "k",
		X = "i",
		Y = "j",
		L = "w",
		R = "o",
		Start = "h",
		Select = "g",
		Up = "e",
		Down = "d",
		Left = "s",
		Right = "f",
		Power = "=",
		Hold = "pause"
	}
end